Package org.eclipse.cdt.core.parser.util

# Class CharTable

java.lang.Object
org.eclipse.cdt.core.parser.util.HashTable
org.eclipse.cdt.core.parser.util.CharTable

All Implemented Interfaces:
  `Cloneable`

Direct Known Subclasses:
  `CharArrayIntMap`, `CharArrayObjectMap`, `CharArraySet`

public class CharTable extends HashTable

Restriction:
  This class is not intended to be subclassed by clients.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected char[][]`
`keyTable`

### Fields inherited from class org.eclipse.cdt.core.parser.util.HashTable

`currEntry, hashTable, minHashSize, nextTable`

## Constructor Summary

Constructors
Constructor
Description
`CharTable(int initialSize)`

## Method Summary

Modifier and Type
Method
Description
`protected final int`
`addIndex(char[] buffer)`
`final int`
`addIndex(char[] buffer, int start, int len)`
`void`
`clear()`
`Object`
`clone()`
`final boolean`
`containsKey(char[] key)`
`final boolean`
`containsKey(char[] key, int start, int len)`
`final char[]`
`findKey(char[] buffer, int start, int len)`
`protected final int`
`hash(char[] obj)`
`protected final int`
`hash(char[] source, int start, int length)`
`protected final int`
`hash(int pos)`
`Object[]`
`keyArray()`
Deprecated.
Use `keys()` instead.
`final char[]`
`keyAt(int i)`
`char[][]`
`keys()`
`int`
`lookup(char[] buffer)`
`protected final int`
`lookup(char[] buffer, int start, int len)`
`protected final int`
`lookup(char[] buffer, int start, int len, int hash)`
`protected void`
`removeEntry(int i)`
`protected void`
`resize(int size)`
`List<char[]>`
`toList()`

### Methods inherited from class org.eclipse.cdt.core.parser.util.HashTable

`capacity, countCollisions, dumpNexts, isEmpty, linkIntoHashTable, partition, rehash, removeEntry, resize, size, sort`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### keyTable

protected char[][] keyTable

## Constructor Details

### CharTable

public CharTable(int initialSize)

## Method Details

### resize

protected void resize(int size)

Overrides:
  `resize` in class `HashTable`

### clear

public void clear()

Overrides:
  `clear` in class `HashTable`

### clone

public Object clone()

Overrides:
  `clone` in class `HashTable`

### hash

protected final int hash(char[] source, int start, int length)

### hash

protected final int hash(int pos)

Overrides:
  `hash` in class `HashTable`

### hash

protected final int hash(char[] obj)

### addIndex

protected final int addIndex(char[] buffer)

### addIndex

public final int addIndex(char[] buffer, int start, int len)

### removeEntry

protected void removeEntry(int i)

### toList

public List<char[]> toList()

### keyAt

public final char[] keyAt(int i)

### containsKey

public final boolean containsKey(char[] key, int start, int len)

### containsKey

public final boolean containsKey(char[] key)

### findKey

public final char[] findKey(char[] buffer, int start, int len)

### lookup

public int lookup(char[] buffer)

### lookup

protected final int lookup(char[] buffer, int start, int len)

### lookup

protected final int lookup(char[] buffer, int start, int len, int hash)

### keys

public char[][] keys()

Since:
  5.7

### keyArray

@Deprecated public Object[] keyArray()
Deprecated.
Use `keys()` instead.